PROBLEM LINK:Editorialist: Lalit Kundu DIFFICULTY:MEDIUM PREREQUISITES:Dynamic Programming PROBLEM:Given interview time lengths and departure times of trains of K(<101) candidates, find the minimum number of candidates that'll miss their trains if we optimally schedule the interviews. Any interview cannot be paused in between. Assume that to catch a train, the interview of each candidate has to end at least 30 minutes before the departure time of the train the candidate wishes to take. Some candidates have trains next day, so for them 1 is given as departure time. Also, since departure times are given in minutes it will be less than 24*60. EXPLANATION:We use dynamic programming. First we'll sort candidates according to decreasing order of departure times and start processing from last candidate in our dp. We define F(i, startTime) as the answer for candidates 1,2,...i, if we start scheduling interviews at time startTime. Note that we'll ignore the candidates with departure time 1 as they don't contribute to answer and we can always schedule there interviews after all other interviews. Here will be the recurrences:
) Complexity: O(K*24*60) worst case. IMPLEMENTATION:See editorialist's detailed solution for implementation details. SOLUTIONS:
This question is marked "community wiki".
asked 25 Dec '14, 00:07

F(i,startTime)= min(F(i,startTime), startTime + interview_time[i]) should be F(i,startTime)= min(F(i,startTime), F(i1, startTime + interview_time[i])) answered 25 Dec '14, 12:04

There's a greedy solution for this. Sort the input according to departure time of the candidate. Then iterate the array maintaining the total time consumed. Every time a candidate who can decrease the total time till now will replace the candidate selected till now consuming the highest. Else the current candidate will not be included. My solution: here. answered 26 Dec '14, 03:07
